'''
@author: darvin
'''
import gtk

class VkBaseSource(object):
    '''
    classdocs
    '''


    def __init__(self):
        '''
        Constructor
        '''
        pass
    
    
    def initialise_actions(self):
        
        shell = self.props.shell
        manager = shell.get_player().get_property('ui-manager')
        self.action_group = gtk.ActionGroup('VkontaktePluginActions')
        
        for act in self.actions_list:
            if act[7]:
                act_type = gtk.ToggleAction
            else:
                act_type = gtk.Action
            action = act_type(act[0], act[1], act[2], act[3])
            action.connect('activate', lambda a: act[4]())
            self.action_group.add_action(action)
        
        
        
        manager.insert_action_group(self.action_group, 0)
        self.ui_id = manager.add_ui_from_string(self.popup_ui)
        manager.ensure_update()
        self.selection_changed_cb(self.entry_view)
        self.entry_view.connect("show_popup", self.do_impl_show_entry_popup)
        self.entry_view.connect("selection_changed", self.selection_changed_cb)
        self.entry_view.connect("have_selection_changed", self.have_selection_changed_cb)
        
        self.ui_actions = []
        for act in self.actions_list:
            self.ui_actions.append(act[0])
        
    def selection_changed_cb(self, entry_view):
        #raise AssertionError
        for act in self.actions_list:
            if act[5]:
                self.action_group.get_action(act[0]).set_sensitive(entry_view.have_selection())
    
    def have_selection_changed_cb(self, entry_view, havsel):
        self.selection_changed_cb(entry_view)

